<cfcomponent output="false">

<cffunction name="init" returntype="Void" output="false"></cffunction>

<cffunction name="load" returntype="Array" output="false">
	<cfargument name="syspath" type="string" required="true">
	<cffile action="read" file="#syspath#\pages\index.xml" variable="nav">
	<cfwddx action="wddx2cfml" input="#nav#" output="index">
	<cfreturn index>
</cffunction>

<cffunction name="save" returntype="Void" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="syspath" type="string" required="true">
	<cfwddx action="cfml2wddx" input="#index#" output="nav">
	<cffile action="write" file="#syspath#\pages\index.xml" output="#nav#">
</cffunction>

<cffunction name="findlocation" returntype="String" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="position" type="string" required="true">
	<cfargument name="syspath" type="string" required="true">
	<cfset pos = listtoarray(position,"-")>
	<cfif arraylen(pos) eq 1 and pos[1] eq 1>
		<cfset location = "Home">
	<cfelse>
		<cfif arraylen(pos) eq 4>
			<cfset location = "Home" & " / " & "#index[pos[1]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].subpages[pos[3]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].subpages[pos[3]].subpages[pos[4]].page#">
		<cfelseif arraylen(pos) eq 3>
			<cfset location = "Home" & " / " & "#index[pos[1]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].subpages[pos[3]].page#">
		<cfelseif arraylen(pos) eq 2>
			<cfset location = "Home" & " / " & "#index[pos[1]].page#" & " / " & "#index[pos[1]].subpages[pos[2]].page#">
		<cfelseif arraylen(pos) eq 1>
			<cfset location = "Home" & " / " & "#index[pos[1]].page#">
		</cfif>
	</cfif>	
	<cfreturn location/>
</cffunction>

<cffunction name="new" returntype="Array" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="position" type="string" required="true">
	<cfargument name="page" type="string" required="true">
	<cfargument name="location" type="string" required="true">
	<cfargument name="syspath" type="string" required="true">

	<cfset pos = listtoarray(position,"-")>
	<cfif arraylen(pos) eq 1 and pos[1] eq 1>
		<cfset result = arrayAppend( index, structNew() )>
		<cfset i = arraylen( index )>
		<cfset index[i].page = "#page#">
		<cfset index[i].location = "#location#">
		<cfset index[i].datemodified = "#now()#">
		<cfset index[i].subpages = ArrayNew(1)>
		<cfset pagepath = syspath&"\pages">
	<cfelse>
		<cfif arraylen(pos) eq 3>
			<cfset ipath = "index[#pos[1]#].subpages[#pos[2]#].subpages[#pos[3]#]">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#\#index[pos[1]].subpages[pos[2]].location#\#index[pos[1]].subpages[pos[2]].subpages[pos[3]].location#">
		<cfelseif arraylen(pos) eq 2>
			<cfset ipath = "index[#pos[1]#].subpages[#pos[2]#]">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#\#index[pos[1]].subpages[pos[2]].location#">
		<cfelseif arraylen(pos) eq 1>
			<cfset ipath = "index[#pos[1]#]">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#">
		</cfif>
		<cfset obj = evaluate(ipath)>
		<cfset result = arrayAppend( obj.subpages, structNew() )>
		<cfset i = arraylen( obj.subpages )>
		<cfset obj.subpages[i].page = "#page#">
		<cfset obj.subpages[i].location = "#location#">
		<cfset obj.subpages[i].datemodified = "#now()#">
		<cfset obj.subpages[i].subpages = ArrayNew(1)>
	</cfif>

	<cffile action="write" file="#pagepath#\#location#.#application.pageext#" output="" nameconflict="OVERWRITE">
	<cfdirectory action="create" directory="#pagepath#\#location#">

	<cfinvoke component="page" method="save">
		<cfinvokeargument name="index" value="#index#">
		<cfinvokeargument name="syspath" value="#syspath#">
	</cfinvoke>

	<cfreturn index/>
</cffunction>

<cffunction name="remove" returntype="Array" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="position" type="string" required="true">
	<cfargument name="syspath" type="string" required="true">

	<cfset pos = listtoarray(position,"-")>
		<cfif arraylen(pos) eq 4>
			<cfset ipath = "index[#pos[1]#].subpages[#pos[2]#].subpages[#pos[3]#].subpages">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#\#index[pos[1]].subpages[pos[2]].location#\#index[pos[1]].subpages[pos[2]].subpages[pos[3]].location#\#index[pos[1]].subpages[pos[2]].subpages[pos[3]].subpages[pos[4]].location#">
			<cfset deleteat = pos[4]>
		<cfelseif arraylen(pos) eq 3>
			<cfset ipath = "index[#pos[1]#].subpages[#pos[2]#].subpages">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#\#index[pos[1]].subpages[pos[2]].location#\#index[pos[1]].subpages[pos[2]].subpages[pos[3]].location#">
			<cfset deleteat = pos[3]>
		<cfelseif arraylen(pos) eq 2>
			<cfset ipath = "index[#pos[1]#].subpages">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#\#index[pos[1]].subpages[pos[2]].location#">
			<cfset deleteat = pos[2]>
		<cfelseif arraylen(pos) eq 1>
			<cfset ipath = "index">
			<cfset pagepath = syspath&"\pages\#index[pos[1]].location#">
			<cfset deleteat = pos[1]>
		</cfif>

		<cfset obj = evaluate(ipath)>
		<cfset result = arraydeleteat(obj,deleteat)>

		<cffile action="delete" file="#pagepath#.#application.pageext#">
		<cfdirectory action="delete" directory="#pagepath#" recurse="yes">

		<cfinvoke component="page" method="save">
			<cfinvokeargument name="index" value="#index#">
			<cfinvokeargument name="syspath" value="#syspath#">
		</cfinvoke>

	<cfreturn index/>
</cffunction>

<cffunction name="settimestamp" returntype="array" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="syspath" type="String" required="true">
	<cfargument name="pagename" type="String" required="true">

	<cfset areas = listtoarray(pagename,"_")>

	<cfif arraylen(areas) gte 1>
	<cfloop from="1" to="#arraylen(index)#" index="f">
	<cfif areas[1] eq index[f].location>
	<cfset index[f].datemodified = now()>
	<cfif arraylen(areas) gte 2>
		<cfloop from="1" to="#arraylen(index[f].subpages)#" index="s">
		<cfif areas[2] eq index[f].subpages[s].location>
		<cfset index[f].subpages[s].datemodified = now()>
		</cfif>
		<cfif arraylen(areas) gte 3>
			<cfloop from="1" to="#arraylen(index[f].subpages[s].subpages)#" index="t">
			<cfif areas[3] eq index[f].subpages[s].subpages[t].location>
			<cfset index[f].subpages[s].subpages[t].datemodified = now()>
			<cfif arraylen(areas) gte 4>
				<cfloop from="1" to="#arraylen(index[f].subpages[s].subpages[t].subpages)#" index="h">
				<cfset index[f].subpages[s].subpages[t].subpages[h].datemodified = now()>
				</cfloop>
			</cfif>
			</cfif>
			</cfloop>
		</cfif>
		</cfloop>
	</cfif>
	</cfif>
	</cfloop>
	</cfif>

	<cfinvoke component="page" method="save">
		<cfinvokeargument name="index" value="#index#">
		<cfinvokeargument name="syspath" value="#syspath#">
	</cfinvoke>

	<cfreturn index/>
</cffunction>

<cffunction name="showtimestamp" returntype="string" output="false">
	<cfargument name="index" type="Array" required="true">
	<cfargument name="syspath" type="String" required="true">
	<cfargument name="pagename" type="String" required="true">

	<cfset timestamp = "#now()#">
	<cfset areas = listtoarray(pagename,"_")>

	<cfif arraylen(areas) gte 1>
	<cfloop from="1" to="#arraylen(index)#" index="f">
	<cfif areas[1] eq index[f].location>
	<cfset timestamp = "#index[f].datemodified#">
	<cfif arraylen(areas) gte 2>
		<cfloop from="1" to="#arraylen(index[f].subpages)#" index="s">
		<cfif areas[2] eq index[f].subpages[s].location>
		<cfset timestamp = "#index[f].subpages[s].datemodified#">
		</cfif>
		<cfif arraylen(areas) gte 3>
			<cfloop from="1" to="#arraylen(index[f].subpages[s].subpages)#" index="t">
			<cfif areas[3] eq index[f].subpages[s].subpages[t].location>
			<cfset timestamp = "#index[f].subpages[s].subpages[t].datemodified#">
			<cfif arraylen(areas) gte 4>
				<cfloop from="1" to="#arraylen(index[f].subpages[s].subpages[t].subpages)#" index="h">
				<cfset timestamp = "#index[f].subpages[s].subpages[t].subpages[h].datemodified#">
				</cfloop>
			</cfif>
			</cfif>
			</cfloop>
		</cfif>
		</cfloop>
	</cfif>
	</cfif>
	</cfloop>
	</cfif>

	<cfset timestamp = "#dateformat(timestamp,"m/d/yyyy")# #timeformat(timestamp,"h:mm tt")#">	
	<cfreturn timestamp/>
</cffunction>

<cffunction name="recordhit" returntype="array" output="false">
	<cfargument name="stats" type="Array" required="true">
	<cfargument name="page" type="String" required="true">

	<cfset found = 0>
	<cfloop from="1" to="#arraylen(stats)#" index="w">
		<cfif stats[w][1] eq page>
			<cfset stats[w][2] = stats[w][2] + 1>
			<cfset found = 1>
		</cfif>
	</cfloop>
	<cfif found eq 0>
		<cfif arraylen(stats) eq 0><cfset w = 1></cfif>
		<cfset stats[w][1] = page>
		<cfset stats[w][2] = 1>
	</cfif>
	<cfreturn stats/>
</cffunction>

</cfcomponent>
